/*    
       This software may be used and distributed according to the terms of
       the GNU General Public License (GPL), incorporated herein by
       reference.  Drivers based on this skeleton fall under the GPL and
       must retain the authorship (implicit copyright) notice.
 
       This program is distributed in the hope that it will be useful, but
       WITHOUT ANY WARRANTY; without even the implied warranty of
       MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
       General Public License for more details.
 */
package beaconconfig;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.util.*;

class Rectangle extends PLine
{
    /* first and third corners are opposite */
    Vertex firstCorner;
    Vertex secondCorner;
    Vertex thirdCorner;
    Vertex fourthCorner;

    public Rectangle(double x, double y) 
    {
	super(x, y);
	firstCorner = this;
    }

    public void draw(Graphics g, DrawingArea drawArea) 
    {
	if(fourthCorner != null) {
	    if(firstCorner.modified) {
		secondCorner.x = firstCorner.x;
		fourthCorner.y = firstCorner.y;
	    }
	    else if(secondCorner.modified) {
		firstCorner.x = secondCorner.x;
		thirdCorner.y = secondCorner.y;
	    }
	    else if(thirdCorner.modified) {
		secondCorner.y = thirdCorner.y;
		fourthCorner.x = thirdCorner.x;
	    }
	    else if(fourthCorner.modified) {
		thirdCorner.x  = fourthCorner.x;
		firstCorner.y  = fourthCorner.y;
	    }

	
	    super.draw(g, drawArea);
	    Vertex start = drawArea.transform(fourthCorner.x, fourthCorner.y);
	    Vertex end   = drawArea.transform(firstCorner.x, firstCorner.y);
	    g.drawLine((int) start.x, (int) start.y, (int) end.x, (int) end.y);
	}
    }

    public Vertex addPoint(double x, double y)
    {
	Util.dbgPrintln("Rectangle addPoint");
	if(thirdCorner == null) {
	    // this.x is firstCorner.x, etc.
	    // x is thirdCorner.x, etc.
	    secondCorner = super.addPoint(this.x, y);
	    thirdCorner  = super.addPoint(x, y);
	    fourthCorner = super.addPoint(x, this.y);
	}
	return firstCorner;
    }

    public Vertex updateCoord(double x, double y)
    {
	thirdCorner.mouseDragged(x, y, null, 0);
	return thirdCorner;
    }

    public String toString()
    {
	return "Rect "+super.toString();
    }
}
